"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const design_system_1 = require("@strapi/design-system");
const helper_plugin_1 = require("@strapi/helper-plugin");
const axios_1 = require("axios");
const react_1 = __importStar(require("react"));
// eslint-disable-next-line no-restricted-imports
const axiosInstance_1 = __importDefault(require("../utils/axiosInstance"));
const WorkflowCard = () => {
    const { slug, initialData } = (0, helper_plugin_1.useCMEditViewDataManager)();
    const [listStages, setListStages] = (0, react_1.useState)([""]);
    const [stage, setStage] = (0, react_1.useState)("");
    const [workflowId, setWorkflowId] = (0, react_1.useState)();
    const [eligibileUsersAndRoles, setEligibileUsersAndRoles] = (0, react_1.useState)([]);
    const [selectApprover, setSelectApprover] = (0, react_1.useState)("");
    const [selectAssignee, setSelectAssignee] = (0, react_1.useState)("");
    const [isStageToggleDisable, setIsStageToggleDisable] = (0, react_1.useState)(true);
    const [errMessage, setError] = (0, react_1.useState)(null);
    function getUserByKey(key) {
        return __awaiter(this, void 0, void 0, function* () {
            const foundUser = eligibileUsersAndRoles.find((user) => user.key === "user" ? user.email === key : user.code === key);
            return foundUser;
        });
    }
    const getWorkflow = (id) => __awaiter(void 0, void 0, void 0, function* () {
        const { data: workflow } = yield axiosInstance_1.default.get(`/review-workflow/${id}/${slug}`);
        return workflow.data;
    });
    const createWorkflow = (value) => __awaiter(void 0, void 0, void 0, function* () {
        var _a, _b;
        try {
            const { data: response } = yield axiosInstance_1.default.post("/review-workflow/create", {
                stage: `${value}`,
                type: slug,
                taskId: initialData.id
            });
            setWorkflowId(response.data.id);
            setStage(value);
        }
        catch (error) {
            let msg = `${error}`;
            if (error instanceof axios_1.AxiosError) {
                msg = `${(_b = (_a = error.response) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.message}`;
            }
            setError(`${msg}`);
        }
    });
    const updateWorkflow = (value, id) => __awaiter(void 0, void 0, void 0, function* () {
        var _c, _d;
        try {
            yield axiosInstance_1.default.put(`/review-workflow/${id}`, { stage: value });
            setStage(value);
        }
        catch (error) {
            let msg = `${error}`;
            if (error instanceof axios_1.AxiosError) {
                msg = `${(_d = (_c = error.response) === null || _c === void 0 ? void 0 : _c.data) === null || _d === void 0 ? void 0 : _d.message}`;
            }
            setError(`${msg}`);
        }
    });
    (0, react_1.useEffect)(() => {
        const fetchStagesAndEligibleUsers = () => __awaiter(void 0, void 0, void 0, function* () {
            var _a, _b;
            try {
                const [{ data: allStages }, { data: eligibleUsers }, { data: eligibleRoles }] = yield Promise.all([
                    axiosInstance_1.default.get("/review-workflow/stages"),
                    axiosInstance_1.default.get("/review-workflow/eligible/users"),
                    axiosInstance_1.default.get("/review-workflow/eligible/roles")
                ]);
                const rolesAndUsers = [...eligibleUsers.data, ...eligibleRoles.data];
                const rolesAndUsersWithKeys = rolesAndUsers.map((entry) => {
                    const keyPrefix = entry.hasOwnProperty("email") ? "user" : "role";
                    const uniqueKey = `${keyPrefix}`;
                    return Object.assign({ key: uniqueKey }, entry);
                });
                let workflowData;
                if (initialData.id) {
                    setIsStageToggleDisable(false);
                    workflowData = yield getWorkflow(initialData.id);
                }
                if (workflowData && Object.keys(workflowData).length > 0) {
                    const approverType = workflowData === null || workflowData === void 0 ? void 0 : workflowData.approverType;
                    const assigneeType = workflowData === null || workflowData === void 0 ? void 0 : workflowData.assigneeType;
                    setStage(workflowData.stage);
                    setWorkflowId(workflowData.id);
                    const normalizeApprover = (workflowData === null || workflowData === void 0 ? void 0 : workflowData.approverType) && capitalizeFirstLetter(`${approverType}`);
                    const approverKey = normalizeApprover && `approverAs${normalizeApprover}`;
                    const approverData = workflowData && workflowData[approverKey];
                    if (approverData) {
                        approverKey === "approverAsUser"
                            ? setSelectApprover(approverData.email)
                            : setSelectApprover(approverData.code);
                    }
                    const normalizeAssignee = (workflowData === null || workflowData === void 0 ? void 0 : workflowData.assigneeType) && capitalizeFirstLetter(`${assigneeType}`);
                    const assigneeKey = normalizeAssignee && `assigneeAs${normalizeAssignee}`;
                    const assigneeData = workflowData && workflowData[assigneeKey];
                    if (assigneeData) {
                        assigneeKey === "assigneeAsUser"
                            ? setSelectAssignee(assigneeData.email)
                            : setSelectAssignee(assigneeData.code);
                    }
                }
                setEligibileUsersAndRoles(rolesAndUsersWithKeys);
                setListStages(allStages.data);
            }
            catch (error) {
                let msg = `${error}`;
                if (error instanceof axios_1.AxiosError) {
                    msg = `${(_b = (_a = error.response) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.message}`;
                }
                setError(msg);
            }
        });
        fetchStagesAndEligibleUsers();
    }, []);
    const approver = (userKey) => __awaiter(void 0, void 0, void 0, function* () {
        var _e, _f;
        try {
            const user = yield getUserByKey(userKey);
            const payload = {
                id: user === null || user === void 0 ? void 0 : user.id,
                approverType: (user === null || user === void 0 ? void 0 : user.code) ? "role" : "user"
            };
            yield axiosInstance_1.default.put(`/review-workflow/${workflowId}/approver`, {
                approverId: Number(payload.id),
                approverType: payload.approverType
            });
            setSelectApprover(userKey);
            return;
        }
        catch (error) {
            let msg = `${error}`;
            if (error instanceof axios_1.AxiosError) {
                msg = `${(_f = (_e = error.response) === null || _e === void 0 ? void 0 : _e.data) === null || _f === void 0 ? void 0 : _f.message}`;
            }
            setError(`${msg}`);
        }
    });
    const assignee = (userKey) => __awaiter(void 0, void 0, void 0, function* () {
        var _g, _h;
        try {
            const user = yield getUserByKey(userKey);
            const payload = {
                id: user === null || user === void 0 ? void 0 : user.id,
                assigneeType: (user === null || user === void 0 ? void 0 : user.code) ? "role" : "user"
            };
            yield axiosInstance_1.default.put(`/review-workflow/${workflowId}/assignee`, {
                assigneeId: Number(payload.id),
                assigneeType: payload.assigneeType
            });
            setSelectAssignee(userKey);
            return;
        }
        catch (error) {
            let msg = `${error}`;
            if (error instanceof axios_1.AxiosError) {
                msg = `${(_h = (_g = error.response) === null || _g === void 0 ? void 0 : _g.data) === null || _h === void 0 ? void 0 : _h.message}`;
            }
            setError(`${msg}`);
        }
    });
    const capitalizeFirstLetter = (str) => {
        return str.charAt(0).toUpperCase() + str.slice(1);
    };
    const handleAlertClose = () => {
        setError(null);
    };
    return (react_1.default.createElement(design_system_1.Box, { as: "aside", "aria-labelledby": "additional-informations", background: "neutral0", borderColor: "neutral150", hasRadius: true, paddingBottom: 4, paddingLeft: 4, paddingRight: 4, paddingTop: 3, shadow: "tableShadow" },
        react_1.default.createElement(design_system_1.Typography, { variant: "sigma", textColor: "neutral600", id: "additional-informations" }, "Review Workflow"),
        react_1.default.createElement(design_system_1.Box, { paddingTop: 2, paddingBottom: 6 },
            react_1.default.createElement(design_system_1.Box, { paddingBottom: 2 },
                react_1.default.createElement(design_system_1.Divider, null)),
            react_1.default.createElement(design_system_1.Box, { paddingTop: 2 },
                errMessage && (react_1.default.createElement(design_system_1.Alert, { closeLabel: "Close", onClose: handleAlertClose, title: "Warning!", variant: "danger" }, errMessage)),
                stage && (react_1.default.createElement(design_system_1.SingleSelect, { label: "Review Stages", value: stage, onChange: (event) => updateWorkflow(event, workflowId), placeholder: "Select Review stage" }, listStages.map((stg) => (react_1.default.createElement(design_system_1.SingleSelectOption, { value: stg }, stg))))),
                !stage && (react_1.default.createElement(design_system_1.SingleSelect, { disabled: isStageToggleDisable, label: "Review Stages", value: stage, onChange: createWorkflow, required: true, placeholder: "Select Review stage" }, listStages.map((stg) => (react_1.default.createElement(design_system_1.SingleSelectOption, { value: stg }, stg))))),
                react_1.default.createElement(design_system_1.SingleSelect, { disabled: stage === "" ? true : false, value: selectApprover, label: "Approver", placeholder: "Select Approver", onChange: (selectedUser) => approver(selectedUser) }, eligibileUsersAndRoles.map((user) => (react_1.default.createElement(design_system_1.SingleSelectOption, { value: user.key === "user" ? user.email : user.code }, `${user.name}`)))),
                react_1.default.createElement(design_system_1.SingleSelect, { disabled: stage === "" ? true : false, value: selectAssignee, label: "Assignee", placeholder: "Select Assignee", onChange: (selectedUserKey) => assignee(selectedUserKey) }, eligibileUsersAndRoles.map((user) => (react_1.default.createElement(design_system_1.SingleSelectOption, { value: user.key === "user" ? user.email : user.code }, `${user.name}`))))))));
};
exports.default = WorkflowCard;
