"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const helper_plugin_1 = require("@strapi/helper-plugin");
const Initializer_1 = __importDefault(require("./components/Initializer"));
const PluginIcon_1 = __importDefault(require("./components/PluginIcon"));
const WorkflowCard_1 = __importDefault(require("./components/WorkflowCard"));
const pluginId_1 = __importDefault(require("./pluginId"));
const name = `workflow`;
exports.default = {
    register(app) {
        app.addMenuLink({
            to: `/plugins/${pluginId_1.default}`,
            icon: PluginIcon_1.default,
            intlLabel: {
                id: `${pluginId_1.default}.plugin.name`,
                defaultMessage: name
            },
            Component: () => __awaiter(this, void 0, void 0, function* () {
                const component = yield Promise.resolve().then(() => __importStar(require(/* webpackChunkName: "[request]" */ "./pages/App")));
                return component;
            }),
            permissions: [
            // Uncomment to set the permissions of the plugin here
            // {
            //   action: '', // the action name should be plugin::plugin-name.actionType
            //   subject: null,
            // },
            ]
        });
        const plugin = {
            id: pluginId_1.default,
            initializer: Initializer_1.default,
            isReady: false,
            name
        };
        app.registerPlugin(plugin);
    },
    bootstrap(app) {
        app.injectContentManagerComponent("editView", "right-links", {
            name: "review-workflow",
            Component: WorkflowCard_1.default
        });
    },
    registerTrads(app) {
        return __awaiter(this, void 0, void 0, function* () {
            const { locales } = app;
            const importedTrads = yield Promise.all(locales.map((locale) => {
                return Promise.resolve(`${`./translations/${locale}.json`}`).then(s => __importStar(require(s))).then(({ default: data }) => {
                    return {
                        data: (0, helper_plugin_1.prefixPluginTranslations)(data, pluginId_1.default),
                        locale
                    };
                })
                    .catch(() => {
                    return {
                        data: {},
                        locale
                    };
                });
            }));
            return Promise.resolve(importedTrads);
        });
    }
};
