"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const helper_plugin_1 = require("@strapi/helper-plugin");
const instance = axios_1.default.create({
    baseURL: process.env.STRAPI_ADMIN_BACKEND_URL,
});
instance.interceptors.request.use((config) => __awaiter(void 0, void 0, void 0, function* () {
    config.headers = {
        Authorization: `Bearer ${helper_plugin_1.auth.getToken()}`,
        Accept: 'application/json',
        'Content-Type': 'application/json',
        "Access-Control-Allow-Origin": "*"
    };
    return config;
}), (error) => {
    Promise.reject(error);
});
instance.interceptors.response.use((response) => response, (error) => {
    var _a;
    // whatever you want to do with the error
    if (((_a = error.response) === null || _a === void 0 ? void 0 : _a.status) === 401) {
        helper_plugin_1.auth.clearAppStorage();
        window.location.reload();
    }
    throw error;
});
exports.default = instance;
