"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.idPathParams = exports.singleEntrySchema = exports.assignBodySchema = exports.approverBodySchema = exports.workflowPathParamsSchema = exports.updateRequestBodySchema = exports.requestBodySchema = void 0;
/* eslint-disable no-restricted-imports */
const zod_1 = require("zod");
exports.requestBodySchema = zod_1.z.object({
    stage: zod_1.z.string({
        required_error: "stage is required",
        invalid_type_error: "stage must be a string"
    }),
    type: zod_1.z.string({
        required_error: "type is required",
        invalid_type_error: "type must be a string"
    }),
    taskId: zod_1.z.number({
        required_error: "taskId is required",
        invalid_type_error: "taskId must be a number"
    })
});
exports.updateRequestBodySchema = zod_1.z.object({
    stage: zod_1.z.string({
        required_error: "stage is required",
        invalid_type_error: "stage must be a string"
    })
});
exports.workflowPathParamsSchema = zod_1.z.number({
    required_error: "workflowId is required",
    invalid_type_error: "workflowId must be a number"
});
exports.approverBodySchema = zod_1.z.object({
    approverId: zod_1.z.number({
        required_error: "approverId is required",
        invalid_type_error: "approverId must be a number",
        description: "This is the user id of the approver"
    }),
    approverType: zod_1.z.enum(["role", "user"], {
        required_error: "approverType is required",
        invalid_type_error: "approverType must be a either role or user"
    })
});
exports.assignBodySchema = zod_1.z.object({
    assigneeId: zod_1.z.number({
        required_error: "assigneeId is required",
        invalid_type_error: "assigneeId must be a number",
        description: "This is the user id of the assignee"
    }),
    assigneeType: zod_1.z.enum(["role", "user"], {
        required_error: "assigneeType is required",
        invalid_type_error: "assigneeType must be a either role or user"
    })
});
exports.singleEntrySchema = zod_1.z.object({
    target_id: zod_1.z.number({
        required_error: "target_id is required",
        invalid_type_error: "target_id must be a number"
    }),
    target_type: zod_1.z.string({
        required_error: "target_type is required",
        invalid_type_error: "target_type must be a string"
    })
});
exports.idPathParams = zod_1.z.number({
    required_error: "id is required",
    invalid_type_error: "id must be a number"
});
