"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPublishAllowed = void 0;
const utils_1 = require("../utils");
const error_1 = require("../utils/error");
console.log(">>>>>>>>>>,got here!!!!!!");
const isPublishAllowed = (arg) => __awaiter(void 0, void 0, void 0, function* () {
    const { uid: slug, id: collectionId } = arg;
    const hasEntry = yield (0, utils_1.findOneEntry)({ uid: slug, id: collectionId !== null && collectionId !== void 0 ? collectionId : "" });
    const isNoEntry = Object.keys(hasEntry).length === 0;
    if (isNoEntry) {
        throw new error_1.ForbiddenError("review stage required");
    }
    const isApproved = `${hasEntry.stage}`.toLowerCase() === "approved";
    if (!isApproved) {
        throw new error_1.ForbiddenError("You can't publish if not approved.");
    }
    return isApproved;
});
exports.isPublishAllowed = isPublishAllowed;
