"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    admin: {
        type: "admin",
        routes: [
            {
                method: "GET",
                path: "/stages",
                handler: "workflowController.allStages",
                config: {
                    policies: [],
                },
            },
            {
                method: "GET",
                path: "/eligible/users",
                handler: "workflowController.eligibleUsers",
                config: {
                    policies: [],
                },
            },
            {
                method: "GET",
                path: "/eligible/roles",
                handler: "workflowController.eligibleRoles",
                config: {
                    policies: [],
                },
            },
            {
                method: "GET",
                path: "/:target_id/:target_type",
                handler: "workflowController.getSingle",
                config: {
                    policies: [],
                },
            },
            {
                method: "POST",
                path: "/create",
                handler: "workflowController.create",
                config: {
                    policies: [],
                },
            },
            {
                method: "DELETE",
                path: "/workflow/:id",
                handler: "workflowController.delete",
            },
            {
                method: "PUT",
                path: "/:id",
                handler: "workflowController.update",
                config: {
                    policies: [],
                },
            },
            {
                method: "PUT",
                path: "/:workflowId/assignee",
                handler: "assigneeController.update",
                config: {
                    policies: [],
                },
            },
            {
                method: "PUT",
                path: "/:workflowId/approver",
                handler: "approverController.update",
                config: {
                    policies: [],
                },
            },
        ],
    }
};
