"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
exports.default = ({ strapi }) => ({
    update(payload) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const { approverId, workflowId, approverType, entry } = payload;
            const previousApproverType = entry === null || entry === void 0 ? void 0 : entry.approverType;
            // unlink the previous type
            if (previousApproverType) {
                const type = (0, utils_1.capitalizeFirstLetter)(previousApproverType);
                yield (0, utils_1.unlinkRelation)({ id: entry.id, link: `approverAs${type}`, type: `approverType` });
            }
            const approverTypeProp = { val: "approverType" };
            const updateApprover = yield ((_a = strapi.entityService) === null || _a === void 0 ? void 0 : _a.update("plugin::review-workflow.workflow", workflowId, {
                data: {
                    [approverTypeProp.val]: `${approverType}`.toLowerCase(),
                    [`approverAs${approverType}`]: approverId
                },
                populate: [`approverAs${approverType}`]
            }));
            let normalizeApprover;
            if (updateApprover === null || updateApprover === void 0 ? void 0 : updateApprover.assigneeAsUser) {
                normalizeApprover = (0, utils_1.mapUserRelationsData)(updateApprover.assigneeAsUser);
            }
            if (updateApprover === null || updateApprover === void 0 ? void 0 : updateApprover.assigneeAsRole) {
                normalizeApprover = (0, utils_1.mapRoleRelationsData)(updateApprover.assigneeAsRole);
            }
            return Object.assign(Object.assign({}, updateApprover), { [`approverAs${approverType}`]: normalizeApprover });
        });
    }
});
