"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
exports.default = ({ strapi }) => ({
    update(payload) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const { assigneeId, workflowId, assigneeType, entry } = payload;
            const previousAssgineeType = entry === null || entry === void 0 ? void 0 : entry.assigneeType;
            if (previousAssgineeType) {
                const type = (0, utils_1.capitalizeFirstLetter)(previousAssgineeType);
                yield (0, utils_1.unlinkRelation)({ id: entry.id, link: `assigneeAs${type}`, type: `assigneeType` });
            }
            const assigneeTypeProp = { val: "assigneeType" };
            const updateAssignee = yield ((_a = strapi.entityService) === null || _a === void 0 ? void 0 : _a.update("plugin::review-workflow.workflow", workflowId, {
                data: {
                    [assigneeTypeProp.val]: `${assigneeType}`.toLowerCase(),
                    [`assigneeAs${assigneeType}`]: assigneeId
                },
                populate: [`assigneeAs${assigneeType}`]
            }));
            let normalizeAssignee;
            if (updateAssignee === null || updateAssignee === void 0 ? void 0 : updateAssignee.assigneeAsUser) {
                normalizeAssignee = (0, utils_1.mapUserRelationsData)(updateAssignee.assigneeAsUser);
            }
            if (updateAssignee === null || updateAssignee === void 0 ? void 0 : updateAssignee.assigneeAsRole) {
                normalizeAssignee = (0, utils_1.mapRoleRelationsData)(updateAssignee.assigneeAsRole);
            }
            return Object.assign(Object.assign({}, updateAssignee), { [`assigneeAs${assigneeType}`]: normalizeAssignee });
        });
    }
});
